Package org.apache.sis.metadata.iso.extent

# Class DefaultExtent

Object
AbstractMetadata
ModifiableMetadata
ISOMetadata
DefaultExtent

All Implemented Interfaces:
  `Serializable`, `Emptiable`, `LenientComparable`, `IdentifiedObject`, `Extent`

@TitleProperty(name="description") public class DefaultExtent extends ISOMetadata implements Extent
Information about spatial, vertical, and temporal extent. The following properties are mandatory or conditional (i.e. mandatory under some circumstances) in a well-formed metadata according ISO 19115:
`EX_Extent` `├─description……………………` The spatial and temporal extent for the referring object. `├─geographicElement……` Geographic component of the extent of the referring object. `├─temporalElement…………` Temporal component of the extent of the referring object. `│ └─extent………………………` The date and time for the content of the dataset. `└─verticalElement…………` Vertical component of the extent of the referring object. `├─minimumValue………` The lowest vertical extent contained in the dataset. `├─maximumValue………` The highest vertical extent contained in the dataset. `└─verticalCRS…………` Information about the vertical coordinate reference system.
This type has four conditional properties: geographic elements, temporal elements, vertical elements and description. At least one of the four shall be used.

In addition to the standard properties, SIS provides the following methods:

- `addElements(Envelope)` for adding extents inferred from the given envelope.
- `Extents​.getGeographicBoundingBox(Extent)` for extracting a global geographic bounding box.

## Limitations

- Instances of this class are not synchronized for multi-threading. Synchronization, if needed, is caller's responsibility.
- Serialized objects of this class are not guaranteed to be compatible with future Apache SIS releases. Serialization support is appropriate for short term storage or RMI between applications running the same version of Apache SIS. For long term storage, use `XML` instead.

Since:
  0.3
See Also:
  - `Extents​.getGeographicBoundingBox(Extent)`
  - `AbstractReferenceSystem​.getDomainOfValidity()`
  - `AbstractDatum​.getDomainOfValidity()`
  - Serialized Form

Defined in the `sis-metadata` module

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class ModifiableMetadata

  `ModifiableMetadata​.State`

- ## Field Summary

  ### Fields inherited from class ISOMetadata

  `identifiers`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `DefaultExtent()`
  Constructs an initially empty extent.
  `DefaultExtent(CharSequence description, GeographicExtent geographicElements, VerticalExtent verticalElements, TemporalExtent temporalElements)`
  Constructs an extent initialized to the given description or components.
  `DefaultExtent(Extent object)`
  Constructs a new instance initialized with the values from the specified metadata object.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addElements(Envelope envelope)`
  Adds geographic, vertical or temporal extents inferred from the given envelope.
  `static DefaultExtent`
  `castOrCopy(Extent object)`
  Returns a SIS metadata implementation with the values of the given arbitrary implementation.
  `InternationalString`
  `getDescription()`
  Returns the spatial and temporal extent for the referring object.
  `Collection<GeographicExtent>`
  `getGeographicElements()`
  Provides geographic component of the extent of the referring object
  `Collection<TemporalExtent>`
  `getTemporalElements()`
  Provides temporal component of the extent of the referring object.
  `Collection<VerticalExtent>`
  `getVerticalElements()`
  Provides vertical component of the extent of the referring object.
  `void`
  `intersect(Extent other)`
  Sets this extent to the intersection of this extent with the specified one.
  `void`
  `setDescription(InternationalString newValue)`
  Sets the spatial and temporal extent for the referring object.
  `void`
  `setGeographicElements(Collection<? extends GeographicExtent> newValues)`
  Sets geographic component of the extent of the referring object.
  `void`
  `setTemporalElements(Collection<? extends TemporalExtent> newValues)`
  Sets temporal component of the extent of the referring object.
  `void`
  `setVerticalElements(Collection<? extends VerticalExtent> newValues)`
  Sets vertical component of the extent of the referring object.

  ### Methods inherited from class ISOMetadata

  `getIdentifier, getIdentifierMap, getIdentifiers, getStandard, setIdentifier, transitionTo`

  ### Methods inherited from class ModifiableMetadata

  `checkWritePermission, collectionType, copyCollection, copyList, copyMap, copySet, deepCopy, nonNullCollection, nonNullList, nonNullMap, nonNullSet, singleton, state, writeCollection, writeList, writeMap, writeSet`

  ### Methods inherited from class AbstractMetadata

  `asMap, asTreeTable, equals, equals, getInterface, hashCode, isEmpty, prune, toString`

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### DefaultExtent

    public DefaultExtent()
    Constructs an initially empty extent.

  - ### DefaultExtent

    public DefaultExtent(CharSequence description, GeographicExtent geographicElements, VerticalExtent verticalElements, TemporalExtent temporalElements)
    Constructs an extent initialized to the given description or components. Any argument given to this constructor can be `null`. While a valid `Extent` requires at least one component to be non-null, this constructor does not perform such verification.
    Parameters:
      `description` - a description, or `null` if none.
      `geographicElements` - a geographic component, or `null` if none.
      `verticalElements` - a vertical component, or `null` if none.
      `temporalElements` - a temporal component, or `null` if none.

  - ### DefaultExtent

    public DefaultExtent(Extent object)
    Constructs a new instance initialized with the values from the specified metadata object. This is a shallow copy constructor, since the other metadata contained in the given object are not recursively copied.
    Parameters:
      `object` - the metadata to copy values from, or `null` if none.
    See Also:
      - `castOrCopy(Extent)`

- ## Method Details

  - ### castOrCopy

    public static DefaultExtent castOrCopy(Extent object)
    Returns a SIS metadata implementation with the values of the given arbitrary implementation. This method performs the first applicable action in the following choices:
    - If the given object is `null`, then this method returns `null`.
    - Otherwise if the given object is already an instance of `DefaultExtent`, then it is returned unchanged.
    - Otherwise a new `DefaultExtent` instance is created using the copy constructor and returned. Note that this is a shallow copy operation, since the other metadata contained in the given object are not recursively copied.
    Parameters:
      `object` - the object to get as a SIS implementation, or `null` if none.
    Returns:
      a SIS implementation containing the values of the given object (may be the given object itself), or `null` if the argument was null.

  - ### getDescription

    public InternationalString getDescription()
    Returns the spatial and temporal extent for the referring object.
    Specified by:
      `getDescription` in interface `Extent`
    Returns:
      the spatial and temporal extent, or `null` in none.

  - ### setDescription

    public void setDescription(InternationalString newValue)
    Sets the spatial and temporal extent for the referring object.
    Parameters:
      `newValue` - the new description.

  - ### getGeographicElements

    public Collection<GeographicExtent> getGeographicElements()
    Provides geographic component of the extent of the referring object
    Specified by:
      `getGeographicElements` in interface `Extent`
    Returns:
      the geographic extent, or an empty set if none.

  - ### setGeographicElements

    public void setGeographicElements(Collection<? extends GeographicExtent> newValues)
    Sets geographic component of the extent of the referring object.
    Parameters:
      `newValues` - the new geographic elements.

  - ### getVerticalElements

    public Collection<VerticalExtent> getVerticalElements()
    Provides vertical component of the extent of the referring object.
    Specified by:
      `getVerticalElements` in interface `Extent`
    Returns:
      the vertical extent, or an empty set if none.

  - ### setVerticalElements

    public void setVerticalElements(Collection<? extends VerticalExtent> newValues)
    Sets vertical component of the extent of the referring object.
    Parameters:
      `newValues` - the new vertical elements.

  - ### getTemporalElements

    public Collection<TemporalExtent> getTemporalElements()
    Provides temporal component of the extent of the referring object.
    Specified by:
      `getTemporalElements` in interface `Extent`
    Returns:
      the temporal extent, or an empty set if none.

  - ### setTemporalElements

    public void setTemporalElements(Collection<? extends TemporalExtent> newValues)
    Sets temporal component of the extent of the referring object.
    Parameters:
      `newValues` - the new temporal elements.

  - ### addElements

    public void addElements(Envelope envelope) throws TransformException
    Adds geographic, vertical or temporal extents inferred from the given envelope. This method inspects the envelope CRS and creates a `GeographicBoundingBox`, `VerticalExtent` or `TemporalExtent` elements as needed.

    Note: this method is available only if the referencing module is on the classpath.

    Parameters:
      `envelope` - the envelope to use for inferring the additional extents.
    Throws:
      `UnsupportedOperationException` - if the referencing module is not on the classpath.
      `TransformException` - if a coordinate transformation was required and failed.
    See Also:
      - `DefaultGeographicBoundingBox​.setBounds(Envelope)`
      - `DefaultVerticalExtent​.setBounds(Envelope)`
      - `DefaultTemporalExtent​.setBounds(Envelope)`

  - ### intersect

    public void intersect(Extent other)
    Sets this extent to the intersection of this extent with the specified one. This method computes the intersections of all geographic, vertical and temporal elements in this extent with all geographic, vertical and temporal elements in the other extent, ignoring duplicated results.
    Parameters:
      `other` - the extent to intersect with this extent.
    Throws:
      `IllegalArgumentException` - if two elements to intersect are not compatible (e.g. mismatched bounding box inclusion status or mismatched vertical datum).
      `UnsupportedOperationException` - if a `TemporalFactory` is required but no implementation has been found on the classpath.
    Since:
      0.8
    See Also:
      - `Extents​.intersection(Extent, Extent)`
      - `GeneralEnvelope​.intersect(Envelope)`